#include<avr/io.h>
#include<util/delay.h>
#include"defines.h"
#include"lcd.h"
#include"adc.h"

/*
All functions for Touchscreen handling
*/

//Initialize ADC
void adc_init(void)
{
	ADMUX=(1<<REFS0);
	ADCSRA=(1<<ADEN);
}

//Read ADC-Channel
int  adc_read(int chan)
{
	chan&=0x0F;
	ADMUX&=0xf0;
	ADMUX|=chan;
	ADCSRA|=(1<<ADSC);
	while(ADCSRA&(1<<ADSC)){}
	return ADCW;
}

//Is LCD touched?
int touched(void)
{
	TOUCH_PORT=0x01;
	TOUCH_DDR=0x04;
	_delay_ms(1);
	return (TOUCH_PIN&0x01)?0:1;
}

//Read raw X
int read_x(void)
{
	TOUCH_PORT=0x04;
	TOUCH_DDR=0x0C;
	_delay_ms(2);
	return adc_read(1);
}

//Read raw Y
int read_y(void)
{
	TOUCH_PORT=0x02;
	TOUCH_DDR=0x03;
	_delay_ms(1);
	return adc_read(2);
}

//Read screen X
int read_xval(void)
{
	long tx=read_x();
	tx-=280;
	tx*=327;
	tx/=1000;
	if(tx<0){tx=0;}
	if(tx>160){tx=160;}
	return tx;
}

//Read screen Y
int read_yval(void)
{
	long ty=read_y();
	ty-=295;
	ty*=192;
	ty/=1000;
	if(ty<0){ty=0;}
	if(ty>80){ty=80;}
	return ty;
}
