#ifndef DEFINES_H
#define DEFINES_H

#include<avr/io.h>

struct bits {
	char b0:1;
	char b1:1;
	char b2:1;
	char b3:1;
	char b4:1;
	char b5:1;
	char b6:1;
	char b7:1;
} __attribute__((__packed__));


#define LCD_DATA_DDR DDRB
#define LCD_DATA_PORT PORTB
#define LCD_DATA_PIN PINB

#define TOUCH_PORT PORTC
#define TOUCH_DDR  DDRC
#define TOUCH_PIN  PINC

#define LCD_CON_DDR DDRD
#define LCD_RS ((*(volatile struct bits*)&PORTD).b0)
#define LCD_RW ((*(volatile struct bits*)&PORTD).b1)
#define LCD_E  ((*(volatile struct bits*)&PORTD).b2)

#define	LCD_CMD_MODE			0x00
#define LCD_CMD_CHAR_PITCH		0x01
#define LCD_CMD_NUM_CHARS		0x02
#define LCD_CMD_TIME_DIVISION		0x03
#define LCD_CMD_CURSOR_POS		0x04

#define LCD_CMD_DISPLAY_START_LA	0x08
#define LCD_CMD_DISPLAY_START_HA	0x09
#define LCD_CMD_CURSOR_LA		0x0A
#define LCD_CMD_CURSOR_HA		0x0B

#define LCD_CMD_WRITE_DATA		0x0C
#define LCD_CMD_READ_DATA		0x0D

#define LCD_CMD_CLEAR_BIT		0x0E
#define LCD_CMD_SET_BIT			0x0F

/* Bits of the LCD Mode Control Register (DB5-DB0) */
#define LCD_MODE_ON_OFF		32
#define LCD_MODE_MASTER_SLAVE	16
#define LCD_MODE_BLINK		8
#define LCD_MODE_CURSOR		4
#define LCD_MODE_MODE		2
#define LCD_MODE_EXTERNAL	1

/* Possible settings of the character pitch register */
/* Horizontal character pitches of 6, 7, and 8 */
#define LCD_CHAR_PITCH_HP_6	0x05
#define LCD_CHAR_PITCH_HP_7	0x06
#define LCD_CHAR_PITCH_HP_8	0x07

/* To indicate the state of a pixel */
#define PIXEL_ON	0xFF
#define PIXEL_OFF	0x00



#endif
